package com.winhc.bigdata.spark.ng.monitor

import org.apache.commons.lang3.StringUtils

/**
 * @author: π
 * @date: 2021/9/9 15:46
 */
object CompanyMonitorUtils {

  def default_filter(update_type: String, biz_date: String, change_fields: Seq[String], old_data: Map[String, String], new_data: Map[String, String]): Boolean = {
    if (biz_date == null) return false
    //if (update_type.equals("remove") || update_type.equals("other")) return false
    if (update_type.equals("update") && change_fields.isEmpty) return false
    true
  }

  def generateId(rowkey: String, biz_date: String, tn: String, random_num: String = null): String = {
    if (StringUtils.isEmpty(random_num)) {
      s"$rowkey@$biz_date@$tn"
    } else {
      s"$rowkey@$biz_date@$tn@$random_num"
    }
  }

  def formatDate(date: String): String = {
    if (StringUtils.isEmpty(date)) {
      null
    } else {
      if (date.contains(" ")) date.split(" ")(0) else date
    }
  }
}
