package com.winhc.bigdata.spark.ng.monitor.table

import com.winhc.bigdata.spark.ng.monitor.{AbstractDailyHandle, ChangeExtract, CompanyMonitorMappings, CompanyMonitorRecord, CompanyMonitorUtils, EntityInfo}
import com.winhc.bigdata.spark.implicits.MapHelper._

import scala.collection.mutable

/**
 * @Date: 2020/8/12 18:50
 * @Description: 限制高消费移除
 */
case class company_zxr_restrict(is_inc: Boolean) extends AbstractDailyHandle {

  override def getEntityInfo(new_data: Map[String, String]): Seq[EntityInfo] = {
    Seq.empty[EntityInfo]
  }

  override def flat_map: (ChangeExtract) => Seq[CompanyMonitorRecord] = (change_extract: ChangeExtract) => {
    var list: mutable.Seq[CompanyMonitorRecord] = mutable.Seq.empty

    val tn = change_extract.tn
    val update_type = change_extract.update_type
    val new_data = change_extract.new_data
    val biz_date = change_extract.biz_date
    val rowkey = change_extract.rowkey
    val update_time = change_extract.update_time

    if (new_data.getOrEmptyStr("deleted").equals("1")) {
      //限制高消费移除
      val `type` = "18"
      val args = CompanyMonitorMappings.get_args(`type`)
      list = list :+ CompanyMonitorRecord(
        id = CompanyMonitorUtils.generateId(rowkey, biz_date, tn, `type`)
        , entity_info = Seq(EntityInfo(keyno = new_data.getOrEmptyStr("company_id"), name = new_data.getOrEmptyStr("company_name"), `type_id` = `type`)
          , EntityInfo(keyno = new_data.getOrEmptyStr("pid"), name = new_data.getOrEmptyStr("person_name"), `type_id` = `type`))
        , dimension_type = args.dimension_type
        , flow_type = args.flow_type
        , rta_desc = ""
        , change_time = biz_date
        , biz_id = rowkey
        , info_risk_level = args.info_risk_level
        , `type` = `type`
        , create_time = update_time
        , amt = get_money(new_data)
        , update_type = update_type
        , deleted = get_deleted(new_data)
      )
    }
    list
  }
}
